package org.planet.snap;

import dermi.*;

import java.io.*;
import java.util.*;
import java.net.*;

import javax.servlet.http.*;
import javax.servlet.*;

public class StartupServlet extends HttpServlet {
  Application snapApp = null;

  public void init (ServletConfig config) throws ServletException {
    super.init (config);
    ServletContext ctx = config.getServletContext();

    try {
        // ----- ATTEMPT TO LOAD LOCAL HOSTNAME -----
        String serverName = InetAddress.getLocalHost().getHostName();
        ctx.setAttribute ("serverName", serverName);

        Properties p = Application.getSnapAppConfig (ctx.getRealPath (File.separator));

        // Create main SNAP application handler
        snapApp = new Application (serverName, p);
        ctx.setAttribute ("SNAPSkel", snapApp);
    } catch (Exception e) {
      System.out.println ("------------------------------ EXCEPTION --------------------------------");
      System.out.println ("-------------------------- Initializing SNAP ----------------------------");
      System.out.println ("-------------------------------------------------------------------------");
      e.printStackTrace();
      throw new ServletException (e.getMessage());
    }
  }

  public void destroy() {
    super.destroy();

    if (snapApp != null) {
      try {
        Registry.leave();
        snapApp.close();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }
}
