package org.planet.snap.deployer;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

public class FinishDialog extends TitleAreaDialog {
  private SnapDeployer win;

  public FinishDialog (Shell parentShell, SnapDeployer w) {
    super (parentShell);
    win = w;
  }

  protected Control createDialogArea (Composite parent) {
    Composite area = (Composite) super.createDialogArea(parent);
    Composite container = new Composite (area, SWT.NONE);
    container.setLayoutData (new GridData (GridData.FILL_BOTH));

    super.getShell().setText ("Snap Deployer");
    Image img = new Image (super.getShell().getDisplay(), "./images/snap_installer.jpg");
    super.getShell().setImage (img);

    setTitle ("SNAP Web Application Signer and Deployer Wizard");
    setMessage("Successful web application deployment.");
    setTitleImage (img);

    final Label label = new Label(container, SWT.NONE);
    label.setBounds(15, 27, 450, 148);
    label.setText("Web application file was successfully signed and deployed on the SNAP infrastructure.\n\n" +
                  "Thank you for using SNAP!\n\n\n\n\n" +
                  "Please press 'Finish' to exit this wizard.");

    final Label label_1 = new Label(container, SWT.SEPARATOR | SWT.HORIZONTAL);
    label_1.setBounds (7, 200, 485, 5);

    return area;
  }

  protected void createButtonsForButtonBar (Composite parent) {
    createButton(parent, IDialogConstants.BACK_ID, IDialogConstants.BACK_LABEL, false);
    createButton(parent, IDialogConstants.FINISH_ID, IDialogConstants.FINISH_LABEL, true);

    final Button back = getButton (IDialogConstants.BACK_ID);
    back.setEnabled (true);
    back.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        Point p = getShell().getLocation();
        close();
        win.openMainOptionsDialog (p);
      }
    });

    Button cancel = getButton (IDialogConstants.FINISH_ID);
    cancel.addSelectionListener (new SelectionAdapter() {
      public void widgetSelected(SelectionEvent event) {
        close();
      }
    });
  }

  protected Point getInitialSize() {
    return new Point (500, 375);
  }
}
